/* -*-c-*-
 *
 * Build table for squaring of binary polynomials
 *
 * (c) 2000 Straylight/Edgeware
 */

/*----- Licensing notice --------------------------------------------------*
 *
 * This file is part of Catacomb.
 *
 * Catacomb is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * Catacomb is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with Catacomb; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

/*----- Header files ------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>

#include <mLib/bits.h>

/*----- Main code ---------------------------------------------------------*/

static void mktab(uint16 *t)
{
  unsigned i, j, x;

  for (i = 0; i < 256; i++) {
    x = 0;
    for (j = 0; j < 8; j++) {
      if (i & (1 << j))
	x |= 1 << (2 * j);
    }
    t[i] = x;
  }
}

int main(void)
{
  uint16 t[256];
  unsigned i;

  mktab(t);
fputs("\
/* -*-c-*-\n\
 *\n\
 * Bit spacing table for binary polynomial squaring\n\
 */\n\
\n\
#include <mLib/bits.h>\n\
\n\
const uint16 gfx_sqrtab[256] = {\n\
  ", stdout);

  for (i = 0; i < 256; i++) {
    printf("0x%04x", t[i]);
    if (i == 255)
      puts("\n};");
    else if (i % 8 == 7)
      fputs(",\n  ", stdout);
    else
      fputs(", ", stdout);
  }

  if (fclose(stdout)) {
    fprintf(stderr, "error writing data\n");
    exit(EXIT_FAILURE);
  }

  return (0);
}

/*----- That's all, folks -------------------------------------------------*/
